#!/usr/bin/perl
package CreateChunks;
use base "Exporter";
@EXPORT = qw(makeChunkArrays);

use strict;
#use warnings;

##########################################################################
# CreateChunks.pm
# Allison Sands
# Takes in chunked sentence files provided by SemEval
# Returns @chunk1 and @chunks2
# Called by ReadGoldOutput
##########################################################################
sub makeChunksArrays
{
    my $line = shift;

    my @lineArray;
    my @chunks;
    my @itemCount;
    my @itemWords;
    my $countTotal;

    @lineArray = split /\] \[/, $line;  #splits each sentence into an array of chunks

    my $i = 0;
    foreach my $token(@lineArray)
    {
	$lineArray[$i] =~ s/[\[|\]]//g;
	$i++;
    }


    my $j = 0;
    foreach my $element(@lineArray) #finds and counts number of words in each chunk
    {					#creates an array of words for each chunk
	@itemWords = split /\s+/, $lineArray[$j];
	$itemCount[$j] = @itemWords - 1;
	$j++;
    }


    $i = 0;
    $countTotal = 0;
    foreach my $token(@itemCount)
    {
	$countTotal += $itemCount[$i];	#total number of words in a chunk
	$i++;
    }

    #Creates @chunks arrays length of sentence, with each element representing that word lives in
    my $m = 0;
    $i = 0; $j = 0; my $a = 0;
    for (my $i = 0; $i < $countTotal; $i++)
    { 
	if ($lineArray[$i] =~ m/\s+[\.|!|?|'|"|:|;|,]+\s+/ && $lineArray[$i] !~ /\w/) {
	    $chunks[$a] = $i;			#If chunk consists of only punctuation, assign 0
	    $a++;
	    $m = 1;
	}
	else {
	    for ($j = 0; $j < $itemCount[$i]; $j++) {
		if ($m)	{ 
		    $chunks[$a] = $i;
		    $a++;
		} 
		else {
		    $chunks[$a] = ($i);
		    $a++;
		    $m = 0;
		}
	    }
	}
    }

    return \@chunks;
}


1;
